

import processing.serial.*;

Serial myPort;

// The next line is needed if running in JavaScript Mode with Processing.js
/* @pjs preload="seedTop.jpg,seedBottom.jpg"; */


HScrollbar hs1, hs2, hs3, hs4, hs5, hs6, hs7, hs8, hs9, hs10, hs11, hs12, hs13, hs14, hs15, hs16, hs17, hs18, hs19, hs20;  // scrollbars

PImage bgimg_01, bgimg_02, bgimg_03, bgimg_04, bgimg_05, bgimg_06, bgimg_07;

int windowHigh = 640;
int windowWidth = 1000;

int sbHing = 26;
int sbWidth = 180 + sbHing;
int marker = 10;
int numData_X = sbWidth + 9;
int numName_X = 25;
int numName = 0;

int S1_X = 160;
int S2_X = S1_X;
int S3_X = S1_X;
int S4_X = S1_X;
int S5_X = S1_X;
int S6_X = S1_X;
int S7_X = S1_X;
int S8_X = S1_X;
int S9_X = S1_X;
int S10_X = S1_X;
int S11_X = S1_X + 400;
int S12_X = S11_X;
int S13_X = S11_X;
int S14_X = S11_X;
int S15_X = S11_X;
int S16_X = S11_X;
int S17_X = S11_X;
int S18_X = S11_X;
int S19_X = S11_X;
int S20_X = S11_X;


int Y_step = 60;
int S1_Y = 40;
int S2_Y = S1_Y + Y_step;
int S3_Y = S2_Y + Y_step;
int S4_Y = S3_Y + Y_step;
int S5_Y = S4_Y + Y_step;
int S6_Y = S5_Y + Y_step;
int S7_Y = S6_Y + Y_step;
int S8_Y = S7_Y + Y_step;
int S9_Y = S8_Y + Y_step;
int S10_Y = S9_Y + Y_step;
int S11_Y = S1_Y;
int S12_Y = S11_Y + Y_step;
int S13_Y = S12_Y + Y_step;
int S14_Y = S13_Y + Y_step;
int S15_Y = S14_Y + Y_step;
int S16_Y = S15_Y + Y_step;
int S17_Y = S16_Y + Y_step;
int S18_Y = S17_Y + Y_step;
int S19_Y = S18_Y + Y_step;
int S20_Y = S19_Y + Y_step;

boolean inputServoNum = true;
int number;
int inputs = 0;
boolean startInput = true;
int inputBox_X = 658;
int inputBox_Y = 280;
int inputBox_High = 36;
int inputBox_Width = 46;
int inputBox_Num_X = inputBox_X + 15;
int inputBox_Num_Y = inputBox_Y + 26;
int inputUpBox_X = inputBox_X + inputBox_Width;
int inputUpBox_Y = inputBox_Y;
int inputUpBox_Width = 20;
int inputUpBox_High = inputBox_High / 2;
int inputDownBox_X = inputBox_X + inputBox_Width;
int inputDownBox_Y = inputBox_Y + (inputBox_High / 2);
int inputDownBox_Width = 20;
int inputDownBox_High = inputBox_High / 2;
int inputUp_X = inputUpBox_X + 2;
int inputUp_Y = inputUpBox_Y + 15;
int inputDown_X = inputDownBox_X + 4;
int inputDown_Y = inputDownBox_Y + 17;
boolean inputUpBox_Over = false;
boolean inputDownBox_Over = false;
int doneBtn_X = inputBox_X + 110;
int doneBtn_Y = inputBox_Y;
int doneBtn_High = inputBox_High;
int doneBtn_Width = 90;
boolean doneBtn_Over = false;
boolean lockedRight = false;
boolean lockedLeft = false;


int ServoNum = 1;
int currentNumber = ServoNum;
int currentScrollData = 0;

int scrolls = 0;

int S1Data;

int[] scrollsData = {
  0, 90, 90, 90, 90, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
};

int previousMillis;
int previousMillisBG;
int BGnum = 0;

void setup() {
  printArray(Serial.list());
  String portName = Serial.list()[1];
  myPort = new Serial(this, portName, 115200);
  size(windowWidth, windowHigh);
  smooth();
  noStroke();
  background(255);
  bgimg_01 = loadImage("roboservo_01_P.png");
  bgimg_02 = loadImage("roboservo_02_P.png");
  bgimg_03 = loadImage("roboservo_03_P.png");
  bgimg_04 = loadImage("roboservo_04_P.png");
  bgimg_05 = loadImage("roboservo_05_P.png");
  bgimg_06 = loadImage("roboservo_06_P.png");
  bgimg_07 = loadImage("roboservo_07_P_08.png");

  //PFont font = createFont("Arial", 32);
  //textFont( font );

  hs1 = new HScrollbar(S1_X, S1_Y + marker, sbWidth, sbHing, sbHing);
  hs2 = new HScrollbar(S2_X, S2_Y + marker, sbWidth, sbHing, sbHing);
  hs3 = new HScrollbar(S3_X, S3_Y + marker, sbWidth, sbHing, sbHing);
  hs4 = new HScrollbar(S4_X, S4_Y + marker, sbWidth, sbHing, sbHing);
  hs5 = new HScrollbar(S5_X, S5_Y + marker, sbWidth, sbHing, sbHing);
  hs6 = new HScrollbar(S6_X, S6_Y + marker, sbWidth, sbHing, sbHing);
  hs7 = new HScrollbar(S7_X, S7_Y + marker, sbWidth, sbHing, sbHing);
  hs8 = new HScrollbar(S8_X, S8_Y + marker, sbWidth, sbHing, sbHing);
  hs9 = new HScrollbar(S9_X, S9_Y + marker, sbWidth, sbHing, sbHing);
  hs10 = new HScrollbar(S10_X, S10_Y + marker, sbWidth, sbHing, sbHing);
  hs11 = new HScrollbar(S11_X, S11_Y + marker, sbWidth, sbHing, sbHing);
  hs12 = new HScrollbar(S12_X, S12_Y + marker, sbWidth, sbHing, sbHing);
  hs13 = new HScrollbar(S13_X, S13_Y + marker, sbWidth, sbHing, sbHing);
  hs14 = new HScrollbar(S14_X, S14_Y + marker, sbWidth, sbHing, sbHing);
  hs15 = new HScrollbar(S15_X, S15_Y + marker, sbWidth, sbHing, sbHing);
  hs16 = new HScrollbar(S16_X, S16_Y + marker, sbWidth, sbHing, sbHing);
  hs17 = new HScrollbar(S17_X, S17_Y + marker, sbWidth, sbHing, sbHing);
  hs18 = new HScrollbar(S18_X, S18_Y + marker, sbWidth, sbHing, sbHing);
  hs19 = new HScrollbar(S19_X, S19_Y + marker, sbWidth, sbHing, sbHing);
  hs20 = new HScrollbar(S20_X, S20_Y + marker, sbWidth, sbHing, sbHing);
}

void draw() {
  int currentMillis = millis();

  if (inputServoNum) {

    if (currentMillis - previousMillisBG > 2200) {
      previousMillisBG = currentMillis;
      BGnum ++;
      if (BGnum == 1) {
        background(bgimg_01);
      }
      if (BGnum == 2) {
        background(bgimg_02);
      }
      if (BGnum == 3) {
        background(bgimg_03);
      }
      if (BGnum == 4) {
        background(bgimg_04);
      }
      if (BGnum == 5) {
        background(bgimg_05);
      }
      if (BGnum == 6) {
        background(bgimg_06);
        BGnum = 0;
      }
      textSize(25);
      fill(0);
      stroke(126);
      strokeWeight(2);
      line(510, 0, 510, 640);
      line(514, 0, 514, 640);
      text("Выберите число серво", inputBox_X - 43, inputBox_Y - 30);
      textSize(30);
      text("SERVOCONTROLLER", 610, 50);
      textSize(12);
      text("created by ZSeregaA - RoboController.ru", 650, 620);
      textSize(25);
      noStroke();
      strokeWeight(1);
    }

    if (keyPressed && keyCode == UP && currentMillis - previousMillis > 120) {
      previousMillis = currentMillis;
      PressUp();
    }

    if (keyPressed && keyCode == DOWN && currentMillis - previousMillis > 120) {
      previousMillis = currentMillis;
      PressDown();
    }

    if (mouseX > inputUpBox_X && mouseX < inputUpBox_X + inputUpBox_Width 
      && mouseY > inputUpBox_Y && mouseY < inputUpBox_Y + inputBox_High / 2) {
      inputUpBox_Over = true;
      fill(255);
      noStroke();
      rect(inputBox_X - 10, inputBox_Y - 10, inputBox_Width + 40, inputBox_High + 20);
      stroke(0);
      rect(inputBox_X, inputBox_Y, inputBox_Width, inputBox_High, 5, 0, 0, 5);
      fill(#4800FF);
      rect(inputUpBox_X, inputUpBox_Y, inputUpBox_Width, inputUpBox_High, 0, 5, 0, 0);
      fill(#CCCCCC);
      rect(inputDownBox_X, inputDownBox_Y, inputDownBox_Width, inputDownBox_High, 0, 0, 5, 0);
      fill(255);
      textSize(21);
      text("+", inputUp_X, inputUp_Y);
      fill(0);
      textSize(25);
      text("-", inputDown_X, inputDown_Y);
      text(currentNumber, inputBox_Num_X, inputBox_Num_Y);
    }
    else {
      inputUpBox_Over = false;
    }

    if (mouseX > inputDownBox_X && mouseX < inputDownBox_X + inputDownBox_Width 
      && mouseY > inputDownBox_Y && mouseY < inputDownBox_Y + inputBox_High / 2) {
      inputDownBox_Over = true;
      fill(255);
      noStroke();
      rect(inputBox_X - 10, inputBox_Y - 10, inputBox_Width + 40, inputBox_High + 20);
      stroke(0);
      rect(inputBox_X, inputBox_Y, inputBox_Width, inputBox_High, 5, 0, 0, 5);
      fill(#CCCCCC);
      rect(inputUpBox_X, inputUpBox_Y, inputUpBox_Width, inputUpBox_High, 0, 5, 0, 0);
      fill(#4800FF);
      rect(inputDownBox_X, inputDownBox_Y, inputDownBox_Width, inputDownBox_High, 0, 0, 5, 0);
      fill(0);
      textSize(21);
      text("+", inputUp_X, inputUp_Y);
      textSize(25);
      fill(255);
      text("-", inputDown_X, inputDown_Y);
      fill(0);
      text(currentNumber, inputBox_Num_X, inputBox_Num_Y);
    }
    else {
      inputDownBox_Over = false;
    }

    if (mouseX > doneBtn_X && mouseX < doneBtn_X + doneBtn_Width 
      && mouseY > doneBtn_Y && mouseY < doneBtn_Y + doneBtn_High) {
      fill(255);
      noStroke();
      rect(inputBox_X - 10, inputBox_Y - 10, inputBox_Width + 170, inputBox_High + 20);
      fill(#4800FF);
      stroke(0);
      rect(doneBtn_X, doneBtn_Y, doneBtn_Width, doneBtn_High, 5);
      fill(255);
      text("Готов", doneBtn_X + 13, doneBtn_Y + 26);
      fill(255);
      stroke(0);
      rect(inputBox_X, inputBox_Y, inputBox_Width, inputBox_High, 5, 0, 0, 5);
      fill(#CCCCCC);
      rect(inputUpBox_X, inputUpBox_Y, inputUpBox_Width, inputUpBox_High, 0, 5, 0, 0);
      rect(inputDownBox_X, inputDownBox_Y, inputDownBox_Width, inputDownBox_High, 0, 0, 5, 0);
      fill(0);
      textSize(21);
      text("+", inputUp_X, inputUp_Y);
      textSize(25);
      text("-", inputDown_X, inputDown_Y);
      text(currentNumber, inputBox_Num_X, inputBox_Num_Y);
      doneBtn_Over = true;
    }
    else {
      doneBtn_Over = false;
      fill(#CCCCCC);
      stroke(0);
      rect(doneBtn_X, doneBtn_Y, doneBtn_Width, doneBtn_High, 5);
      fill(0);
      text("Готов", doneBtn_X + 13, doneBtn_Y + 26);
    }

    if (inputUpBox_Over && mousePressed && currentMillis - previousMillis > 120) {
      previousMillis = currentMillis;
      PressUp();
    }

    if (inputDownBox_Over && mousePressed && currentMillis - previousMillis > 120) {
      previousMillis = currentMillis;
      PressDown();
    }

    if (doneBtn_Over && mousePressed) {
      inputServoNum = false;
      ServoNum = currentNumber;
      background(255);
    }

    if (!keyPressed && !inputUpBox_Over && !inputDownBox_Over && !doneBtn_Over) {
      fill(255);
      noStroke();
      rect(inputBox_X - 10, inputBox_Y - 10, inputBox_Width + 170, inputBox_High + 20);
      fill(#CCCCCC);
      stroke(0);
      rect(doneBtn_X, doneBtn_Y, doneBtn_Width, doneBtn_High, 5);
      fill(0);
      text("Готов", doneBtn_X + 13, doneBtn_Y + 26);
      fill(255);
      stroke(0);
      rect(inputBox_X, inputBox_Y, inputBox_Width, inputBox_High, 5, 0, 0, 5);
      fill(#CCCCCC);
      rect(inputUpBox_X, inputUpBox_Y, inputUpBox_Width, inputUpBox_High, 0, 5, 0, 0);
      rect(inputDownBox_X, inputDownBox_Y, inputDownBox_Width, inputDownBox_High, 0, 0, 5, 0);
      fill(0);
      textSize(21);
      text("+", inputUp_X, inputUp_Y);
      textSize(25);
      text("-", inputDown_X, inputDown_Y);
      text(currentNumber, inputBox_Num_X, inputBox_Num_Y);
    }

    if (key == '\n') {
      inputServoNum = false;
      ServoNum = currentNumber;
      background(255);
    }
  }

  if (!inputServoNum) {

    background(bgimg_07);

    if (ServoNum > 0) {
      hs1.update();

      hs1.display();
    }
    if (ServoNum > 1) {
      hs2.update();
      hs2.display();
    }
    if (ServoNum > 2) {
      hs3.update();
      hs3.display();
    }
    if (ServoNum > 3) {
      hs4.update();
      hs4.display();
    }

    if (ServoNum > 4) {
      hs5.update();
      hs5.display();
    }

    if (ServoNum > 5) {
      hs6.update();
      hs6.display();
    }

    if (ServoNum > 6) {
      hs7.update();
      hs7.display();
    }

    if (ServoNum > 7) {
      hs8.update();
      hs8.display();
    }

    if (ServoNum > 8) {
      hs9.update();
      hs9.display();
    }

    if (ServoNum > 9) {
      hs10.update();
      hs10.display();
    }

    if (ServoNum > 10) {
      hs11.update();
      hs11.display();
    }

    if (ServoNum > 11) {
      hs12.update();
      hs12.display();
    }

    if (ServoNum > 12) {
      hs13.update();
      hs13.display();
    }

    if (ServoNum > 13) {
      hs14.update();
      hs14.display();
    }

    if (ServoNum > 14) {
      hs15.update();
      hs15.display();
    }

    if (ServoNum > 15) {
      hs16.update();
      hs16.display();
    }

    if (ServoNum > 16) {
      hs17.update();
      hs17.display();
    }

    if (ServoNum > 17) {
      hs18.update();
      hs18.display();
    }

    if (ServoNum > 18) {
      hs19.update();
      hs19.display();
    }

    if (ServoNum > 19) {
      hs20.update();
      hs20.display();
    }
  }
}


class HScrollbar {
  int swidth, sheight;    // width and height of bar
  int xpos, ypos;       // x and y position of bar
  int spos, newspos, tempnewspos, currentspos;    // x position of slider
  int sposMin, sposMax; // max and min values of slider
  int loose;              // how loose/heavy
  boolean over;           // is the mouse over the slider?
  boolean locked;
  int ratio;

  HScrollbar (int xp, int yp, int sw, int sh, int l) {
    swidth = sw;
    sheight = sh;
    int widthtoheight = sw - sh;
    ratio = (int)sw / (int)widthtoheight;
    xpos = xp;
    //numofScroll = xpos - (xp - 1);
    ypos = yp-sheight/2;
    spos = xpos;
    newspos = spos;
    tempnewspos = spos;
    sposMin = xpos;
    sposMax = xpos + swidth - sheight;
    loose = l;
  }

  void update() {
    if (overEvent()) {
      over = true;
    } 
    else {
      over = false;
    }
    if (mousePressed && over) {
      locked = true;
    }
    if (!mousePressed) {
      locked = false;
    }

    if (locked) {
      newspos = constrain(mouseX-sheight/2, sposMin, sposMax);
    }

    int currentMillis = millis();
    if (!keyPressed) {
      lockedRight = false;
      lockedLeft = false;
    }
    if (over && keyPressed && key == CODED && currentMillis - previousMillis > 150) {
      previousMillis = currentMillis;
      if (keyCode == RIGHT && newspos != sposMax) {
        newspos++;
        lockedRight = true;
      }

      if (keyCode == LEFT && newspos != sposMin) {
        newspos--;
        lockedLeft = true;
      }
    }

    if (abs(newspos - spos) > 0) {
      spos = spos + (newspos-spos);
      currentScrollData = spos - xpos;
    }

    if (mouseX > S1_X && mouseX < S1_X+swidth && mouseY > S1_Y - 5 && mouseY < S1_Y + sheight && currentScrollData != scrollsData[1]) {
      if (locked || lockedRight || lockedLeft) {
        fill(255);
        stroke(0);
        rect(798, 5, 150, 20);
        scrollsData[1] = currentScrollData;
        fill(0);
        //text("Servo 1", 800, 20);
        //text(scrollsData[1], 880, 20);
        myPort.write(1);
        myPort.write(scrollsData[1]);
      }
    }
    if (mouseX > S2_X && mouseX < S2_X+swidth && mouseY > S2_Y - 5 && mouseY < S2_Y+sheight && currentScrollData != scrollsData[2]) {
      if (locked || lockedRight || lockedLeft) {
        fill(255);
        stroke(0);
        rect(798, 25, 150, 20);
        scrollsData[2] = currentScrollData;
        fill(0);
        //text("Servo 2", 800, 40);
        //text(scrollsData[2], 880, 40);
        myPort.write(2);
        myPort.write(scrollsData[2]);
      }
    }
    if (mouseX > S3_X && mouseX < S3_X+swidth && mouseY > S3_Y - 5 && mouseY < S3_Y+sheight && currentScrollData != scrollsData[3]) {
      if (locked || lockedRight || lockedLeft) {
        fill(255);
        stroke(0);
        rect(798, 45, 150, 20);
        scrollsData[3] = currentScrollData;
        fill(0);
        //text("Servo 3", 800, 60);
        //text(scrollsData[3], 880, 60);
        myPort.write(3);
        myPort.write(scrollsData[3]);
      }
    }
    if (mouseX > S4_X && mouseX < S4_X+swidth && mouseY > S4_Y - 5 && mouseY < S4_Y+sheight && currentScrollData != scrollsData[4]) {
      if (locked || lockedRight || lockedLeft) {
        fill(255);
        stroke(0);
        rect(798, 45, 150, 20);
        scrollsData[4] = currentScrollData;
        fill(0);
        //text("Servo 4", 800, 60);
        //text(scrollsData[4], 880, 60);
        myPort.write(4);
        myPort.write(scrollsData[4]);
      }
    }

    /*
    if (mouseX > S1_X && mouseX < S1_X+swidth &&
     mouseY > S1_Y && mouseY < S1_Y+sheight && locked) {
     if ((spos - xpos) != scrollsData[1]){
     fill(255);
     noStroke();
     rect(798, 00, 150, 30);
     scrollsData[1] = spos - xpos;
     fill(0);
     text("Servo 1", 800, 20);
     text(scrollsData[1], 880, 20);
     }
     }
     */


// set scroll data to scrolls
     if (scrolls != ServoNum) {
     scrolls++;
     if (scrolls <= 10) {
     newspos = scrollsData[scrolls] + S1_X;
     spos = spos + (newspos-spos);
     }
     if (scrolls > 10) {
     newspos = scrollsData[scrolls] + S11_X;
     spos = spos + (newspos-spos);
     }
     }
  }

  int constrain(int val, int minv, int maxv) {
    return min(max(val, minv), maxv);
  }

  boolean overEvent() {

    if (mouseX > xpos && mouseX < xpos+swidth &&
      mouseY > ypos && mouseY < ypos+sheight) {
      return true;
    } 
    else {
      locked = false;
      return false;
    }
  }

  void display() {
    smooth();
    fill(255);
    //noStroke();
    //rect(xpos - 32, ypos - 30, sheight + sbWidth + 54, sheight + 32);
    stroke(0);
    rect(xpos - 30, ypos - 1, sheight + sbWidth + 50, sheight + 1, 7);
    noStroke();
    fill(#B7B7B7);
    rect(xpos, ypos, swidth, sheight);
    if (over || locked) {
      fill(#FF0000);
      //stroke(0);
    } 
    else {
      fill(0);
      // noStroke();
    }


    rect(spos, ypos, sheight, sheight);

    // Display data of sliders
    //fill(255);
    //rect(xpos + numData_X, ypos, sbHing + 5, sbHing);
    fill(0);
    textSize(16);
    text(spos - xpos, xpos + numData_X, ypos + (marker + 8));


    if (numName != ServoNum) {
      numName++;
      if (numName < 10) {
        fill(#404040);
        textSize(15);
        text(numName, xpos - (numName_X - 5), ypos + (marker + 8));
      }
      if (numName > 9) {
        fill(#404040);
        textSize(15);
        text(numName, xpos - numName_X + 1, ypos + (marker + 8));
      }
    }
    if (numName == ServoNum) {
      numName = 0;
    }



    if (!mousePressed && mouseX > xpos && mouseX < xpos+swidth && mouseY > ypos && mouseY < ypos+sheight) {
      tempnewspos = constrain(mouseX-sheight/2, sposMin, sposMax);
      /*
      fill(255);
       rect(xpos, ypos - (sbHing + 5), sbWidth, sbHing);
       */
      //fill(#B7B7B7);
      fill(0);
      text(tempnewspos - xpos, tempnewspos, ypos - (sbHing / 2));
    }
    /*
    else {
     fill(255);
     rect(xpos, ypos - (sbHing + 5), sbWidth, sbHing);
     }
     */
  }
}

void PressUp () {
  if (currentNumber < 20) {
    currentNumber ++;
  }
  if (currentNumber >= 10) {
    inputBox_Num_X = inputBox_X + 8;
  }
  fill(255);
  noStroke();
  rect(inputBox_X - 10, inputBox_Y - 10, inputBox_Width + 40, inputBox_High + 20);
  stroke(0);
  rect(inputBox_X, inputBox_Y, inputBox_Width, inputBox_High, 5, 0, 0, 5);
  fill(#4800FF);
  rect(inputUpBox_X, inputUpBox_Y, inputUpBox_Width, inputUpBox_High, 0, 5, 0, 0);
  fill(#CCCCCC);
  rect(inputDownBox_X, inputDownBox_Y, inputDownBox_Width, inputDownBox_High, 0, 0, 5, 0);
  fill(255);
  textSize(21);
  text("+", inputUp_X, inputUp_Y);
  fill(0);
  textSize(25);
  text("-", inputDown_X, inputDown_Y);
  text(currentNumber, inputBox_Num_X, inputBox_Num_Y);
}

void PressDown() {
  if (currentNumber > 1) {
    currentNumber --;
  }
  if (currentNumber <= 9) {
    inputBox_Num_X = inputBox_X + 15;
  }
  fill(255);
  noStroke();
  rect(inputBox_X - 10, inputBox_Y - 10, inputBox_Width + 40, inputBox_High + 20);
  stroke(0);
  rect(inputBox_X, inputBox_Y, inputBox_Width, inputBox_High, 5, 0, 0, 5);
  fill(#CCCCCC);
  rect(inputUpBox_X, inputUpBox_Y, inputUpBox_Width, inputUpBox_High, 0, 5, 0, 0);
  fill(#4800FF);
  rect(inputDownBox_X, inputDownBox_Y, inputDownBox_Width, inputDownBox_High, 0, 0, 5, 0);
  fill(0);
  textSize(21);
  text("+", inputUp_X, inputUp_Y);
  textSize(25);
  fill(255);
  text("-", inputDown_X, inputDown_Y);
  fill(0);
  text(currentNumber, inputBox_Num_X, inputBox_Num_Y);
}

/*
void keyPressed() {
 // get the value of the key pressed
 number = int(key);  // int('0') = 48
 number = number - 48;
 if (keyPressed) {
 if (inputs != 3) {
 inputs ++;
 }
 if (inputs == 3) {
 currentNumber = 0;
 inputs = 0;
 }
 }
 if (number >= 0 && number <= 9) {
 if (currentNumber > 0 && currentNumber < 10) {
 currentNumber = currentNumber * 10;
 }
 currentNumber = currentNumber + number;
 if (currentNumber > 20) {
 currentNumber = 0;
 }
 }
 else {
 println("Invalid you pressed " + key);
 }
 } 
 */

void sendScrillData() {
}

